'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

/**
 * Default element to input a value for a Rule in the QueryBuilder
 */
var ValueEditor = function ValueEditor(props) {
  var operator = props.operator,
      value = props.value,
      handleOnChange = props.handleOnChange,
      title = props.title,
      className = props.className;


  if (operator === 'null' || operator === 'notNull') {
    return null;
  }

  return _react2.default.createElement('input', { type: 'text',
    className: className,
    value: value,
    title: title,
    onChange: function onChange(e) {
      return handleOnChange(e.target.value);
    } });
};

ValueEditor.displayName = 'ValueEditor';

ValueEditor.propTypes = {
  /**
   * field name corresponding to this Rule
   */
  field: _propTypes2.default.string,
  /**
   * operator name corresponding to Rule using the element
   */
  operator: _propTypes2.default.string,
  /**
   * value from the existing query representation, if any
   */
  value: _propTypes2.default.string,
  /**
   * callback function to invoke when the element changes
   */
  handleOnChange: _propTypes2.default.func,
  /**
   * html title
   */
  title: _propTypes2.default.string,
  /**
   * //css className to be applied
   */
  className: _propTypes2.default.string
};

exports.default = ValueEditor;